/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 *
 */

package net.dries007.tfc.objects.container;

import javax.annotation.Nonnull;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.Slot;
import net.minecraft.tileentity.TileEntity;

public abstract class ContainerTFC<TE extends TileEntity> extends Container
{
    protected TE tile;

    ContainerTFC(InventoryPlayer playerInv, TE te)
    {
        this.tile = te;

        addContainerSlots(te);
        addPlayerInventorySlots(playerInv);
    }

    @Override
    public boolean func_75145_c(@Nonnull EntityPlayer player)
    {
        return true;
    }

    protected abstract void addContainerSlots(TE tile);

    private void addPlayerInventorySlots(InventoryPlayer playerInv)
    {
        // Add Player Inventory Slots
        for (int i = 0; i < 3; i++)
        {
            for (int j = 0; j < 9; j++)
            {
                func_75146_a(new Slot(playerInv, j + i * 9 + 9, 8 + j * 18, 84 + i * 18));
            }
        }

        for (int k = 0; k < 9; k++)
        {
            func_75146_a(new Slot(playerInv, k, 8 + k * 18, 142));
        }
    }
}
