/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.world.classic.worldgen;

import java.util.Random;

import net.minecraft.block.Block;
import net.minecraft.block.BlockPumpkin;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.gen.feature.WorldGenerator;

import net.dries007.tfc.objects.blocks.BlocksTFC;

public class WorldGenPumpkinTFC extends WorldGenerator
{
    private final Block pumpkin;

    public WorldGenPumpkinTFC(Block pumpkin)
    {
        this.pumpkin = pumpkin;
    }

    @Override
    public boolean func_180709_b(World world, Random rng, BlockPos start)
    {
        for (int i = 0; i < 32; ++i)
        {
            BlockPos pos = start.func_177982_a(rng.nextInt(8) - rng.nextInt(8), rng.nextInt(4) - rng.nextInt(4), rng.nextInt(8) - rng.nextInt(8));

            if (!world.func_175623_d(pos) && !pumpkin.func_176196_c(world, pos)) continue;
            if (!BlocksTFC.isSoil(world.func_180495_p(pos.func_177982_a(0, -1, 0)))) continue;

            world.func_180501_a(pos, pumpkin.func_176223_P().func_177226_a(BlockPumpkin.field_185512_D, EnumFacing.Plane.HORIZONTAL.func_179518_a(rng)), 2);
        }

        return true;
    }
}
